import render.*;

public class Block extends Geometry {

	// INSTANCE DATA
	public boolean taken = false;     // a polly has picked up this block
	public final static int numFactors = 2; // factors determine how pollys will
	public double factors[] = new double[numFactors];    // react to this block

	public double x=0, z=0, theta=0, size=1;

	// STATIC DATA
	// defines the vertices of a cube 
	static double cubeVert[][] = {
		{1,0,0}, {0,1,0}, {0,0,1}, {1,1,0}, {1,1,1}, {1,0,1}, {0,1,1}, {0,0,0}
	}; 

	// faces defined by counter-clockwise list of (above) vertices	
	static int cubeFaces[][] = {
		{0,3,4,5}, {1,6,4,3}, {1,7,2,6}, {0,5,2,7}, {7,1,3,0}, {5,4,6,2} }; 

	static Material red = (new Material()).setColor(1,0,0, 1,1,1,10, .2,0,0);

	public Block() {
		setMaterial(red);

		Geometry cube = add();
		cube.faces = cubeFaces;
		cube.vertices = new double[cubeVert.length][6];
		for (int i=0; i < cubeVert.length; i++)
			for (int j=0; j<3; j++)
				cube.vertices[i][j] = cubeVert[i][j];
		Matrix.translate(cube.matrix,-.5,0,-.5);
	}

	public Block setColor(double r, double g, double b) {
		child[0].setMaterial(
			(new Material()).setColor(r,g,b, 1,1,1,10, .2*r,.2*g,.2*b));
		return this;
	}

	public Block setSize(double Size) {
		size = Size; 
		return this;
	}

	public Block setPosition(double X, double Z) {
		x = X; 
		z = Z; 
		return this;
	}

	public Block setDirection(double Theta) {
		theta = Theta; 
		return this;
	}

	public Block setFactors(double f[]) {
		if (f.length != numFactors) {
			System.out.println("Incorrect size!!!");
			return null;
		}
		factors = f;
		return this;
	}

	public void animate(double time) {
		Matrix.identity(matrix);
		Matrix.translate(matrix,x,(taken?1:0),z);
		Matrix.rotateY(matrix,Math.PI + theta);
		Matrix.scale(matrix,size,size,size);
	}
}
